# SourcePath: glibc/20071003
Summary: The GNU C Library.
Name: sony-target-dev-glibc-for-dev
%define pkgname %{sony_target_config}-dev-glibc-for-dev
Version: 2.5
Release: 030505
License: LGPL2.1 / Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.gnu.org/software/libc
Source0: glibc-%{version}.tar.bz2
Source1: glibc-linuxthreads-%{version}.tar.bz2
Source2: glibc-ports-%{version}.tar.bz2

# LOT script Files
Source10: sony-devel-libopt-build-libc
Source11: sony-devel-libopt-build-libcrypt
Source12: sony-devel-libopt-build-libdl
Source13: sony-devel-libopt-build-libm
Source14: sony-devel-libopt-build-libpthread
Source15: sony-devel-libopt-build-librt

#
# Patches 

# Linux From Scratch patches: http://www.linuxfromscratch.org/clfs/view/CLFS-SYSROOT-SVN-0.0.1-20061202/x86/materials/patches.html
Patch100: glibc-2.5-libgcc_eh-2.patch
Patch101: glibc-2.5-minor-version.patch

# Linuxthreads with TLS support

# General patches
  # The patches to fix the build or link error newly appeared at 2.5
  # (Basically those causes by using the linuxthread (with tls) setting)
  #
Patch200: glibc-2.5-getcwd-max-def.patch

  # The patches created by SS, which were applied already for 2.3.6
	# For system() API under the linuxthreads environment
Patch220: glibc-2.3.6-system-under-linuxthreads.patch
	# For mknod() on mips , for the 32bit device number.
Patch221: glibc-ports-2.5-mips-mknod.patch

        # Fix the race between dlxxx and the lazy bind
Patch222: glibc-2.5-dl-ld-race.patch

	# Fix resolver using IPv6
Patch223: glibc-2.5-ipv6bug.patch

	# Fix inet6_xxx() 
Patch224: glibc-2.5-inet6-opt.patch

Patch225: glibc-2.5-mips-dl-ld-race.patch
patch226: glibc-2.5-move-rtld-linkmap-member.patch

# Arch specific patches
# Note: Use glibc-ports-2.5.tar.bz2 for arch specific ports,
#       with --enable-add-ons=glibc-ports-2.5.

  # i386
Patch300: glibc-2.5-i386-allow-i386.patch
Patch301: glibc-2.5-i386-pow.patch          

  # powerpc
# powerpc soft-fp patch http://sourceware.org/bugzilla/show_bug.cgi?id=2749
Patch325: glibc-2.5-ppc-sfp-move-20060731.patch
Patch326: glibc-2.5-ports-sfp-move-20060731.patch
Patch327: glibc-2.5-ports-ld-nofpu-20060830.patch
Patch328: glibc-2.5-ppc-ld-nofpu-20060920.patch
Patch329: glibc-2.5-ports-ld-delta-20060920.patch
Patch330: glibc-2.5-ports-more-ulps.patch
# powerpc soft-fp patch http://sourceware.org/bugzilla/show_bug.cgi?id=3268
Patch331: ports-fma-20060920.patch
Patch332: ppc-fma-20060920.patch
Patch333: ppc-fma-libm-test-20060920.patch
# patch to fix multiple def of __gtdf2 on libgcc.a and libc.a for powerpc
Patch334: glibc-2.5-soft-fp-separate-strong-alias.patch

  # arm
Patch340: glibc-ports-2.5-linuxthreads-arm-allow-tls.patch
Patch341: glibc-ports-2.5-arm-obsolete-syscall-support.patch
Patch342: glibc-ports-2.5-arm-signal-unwinding-for-newer-kernel.patch
Patch343: glibc-ports-2.5-arm-avoid-using-asm-procinfo.patch
Patch344: glibc-ports-2.5-arm-ioperm.patch
Patch345: glibc-ports-2.5-arm-memxxx.patch
Patch346: glibc-2.5-arm-pselect-ppoll.patch

  # mips
# Disable TLS feature on MIPS, due to performance decline.
# Patch360: glibc-2.5-linuxthreads-mips-allow-tls.patch
Patch361: glibc-ports-2.5-mips-mathdef.patch
Patch362: glibc-2.5-mips-gnu-hash.patch
Patch363: glibc-2.5-mips-update-msqid_ds.patch

# MIPS prelink patches
Patch364: glibc-2.5-elf-glob-dat.patch
Patch365: glibc-ports-2.5-mips-rela.patch
Patch366: glibc-ports-2.5-glob-dat.patch
Patch367: glibc-2.5-realloc.patch

# MIPS dlsym patches
Patch368: glibc-2.5-mips-dlsym-next.patch

# Sony SS Original
  # Linuxthreads patch,add pthread_cond_timedwait_reltime_np API
Patch400: glibc-2.3.6-linuxthreads-cond_timedwait_rel-060614.patch

  # Make fatal error warn when using the wrong kernel version
Patch401: glibc-2.5-rtld-osinfo-nonfatal.patch

  # fix linuxthreads sigaction wrapper problem.
Patch402: glibc-2.5-fix-linuxthreads-sigaction-wrapper.patch

  # hp-timing support
Patch420: glibc-2.5-hp-timing-ctors.patch
Patch421: glibc-ports-2.5-ppc-hp-timing.patch
Patch422: glibc-2.5-i386-hp-timing.patch
Patch423: glibc-ports-2.5-mips-hp-timing.patch
Patch424: glibc-2.5-mips-got-hp-timing.patch
Patch425: glibc-2.5-mips-hp-timing-rtld.patch
Patch426: glibc-2.5-mips-hp-timing-etc.patch

  # fix dl_load_lock not initialized on fork from thread
Patch427: glibc-2.5-atfork-lock-init.patch


BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_cross_target_dir}

BuildRequires: %{sony_target_config}-cross-libopt-for-dev

%description
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%package -n %{pkgname}
Summary: The GNU C Library.
Group: %{sony_group}
AutoReqProv: no

Conflicts: %{sony_target_config}-dev-glibc-bootstrap-headers

%description -n %{pkgname}
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%prep
%setup -q -n glibc-%{version} -q -a 1 -q -a 2

# Apply patches
%patch100 -p1
%patch101 -p0

%patch200 -p0

%patch220 -p1
%patch221 -p0
%patch222 -p1
%patch223 -p1
%patch224 -p1
%patch225 -p1
%patch226 -p1

%patch300 -p1
%patch301 -p1

%patch325 -p1
%patch326 -p1
%patch327 -p1
%patch328 -p1
%patch329 -p1
%patch330 -p1
%patch331 -p1
%patch332 -p1
%patch333 -p1
%patch334 -p1

%patch340 -p0
%patch341 -p1
%patch342 -p1
%patch343 -p1
%patch344 -p0
%patch345 -p0
%patch346 -p0

# Disable TLS feature on MIPS, due to performance decline.
# %patch360 -p1
%patch361 -p0
%patch362 -p1
%patch363 -p1
%patch364 -p0
%patch365 -p0
%patch366 -p0
%patch367 -p0

%patch368 -p1

%patch400 -p1
%patch401 -p1
%patch402 -p1

%patch420 -p1
%patch421 -p0
%patch422 -p1
%patch423 -p0
%patch424 -p1
%patch425 -p1
%patch426 -p1
%patch427 -p1

#
# NOTE: Build with linuxthreads, with TLS
#
%build
%sony_target_dev_setup

%define _header_dir %{sony_cross_target_dir}%{sony_target_dev_include_dir}

%if "%{sony_target_cpu}" == "arm"
# compile option for EX project
export CFLAGS="-O2 -g -fno-omit-frame-pointer"
%endif

autoconf &&
%if "%{sony_target_cpu}" == "ppc"
   export libc_cv_ppc_machine=yes \
	  libc_cv_ppc_rel16=no \
%endif
%sony_target_dev_configure \
	--enable-add-ons=glibc-ports-%{version},linuxthreads \
	--disable-sanity-checks \
	--without-cvs \
%if "%{sony_target_fpu}" == "no"
	--without-fp \
%endif
	--with-tls \
%if "%{sony_target_cpu}" == "mips"
	--without-__thread \
%else
	--with-__thread \
%endif
%if "%{kernel_version_ge_2_6_21}" == "yes"
	--enable-kernel=2.6.22 \
%else
	--enable-kernel=2.6.16 \
%endif
	--without-gd \
	--with-headers=%{_header_dir} &&
cat <<EOF > configparms &&
slibdir=%{sony_target_dev_dir}/lib
sysconfdir=%{sony_target_dev_dir}/etc
EOF
make

%install
%sony_target_dev_setup

rm -rf %{buildroot}

mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/libc
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/libcrypt
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/libdl
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/libm
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/libpthread
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo/librt
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libc_pic

cd %{sony_objdir} &&
make \
    install_root=%{buildroot}%{sony_cross_target_dir} \
    install

#
# Copy real semaphore.h , in linuxthreads/semaphore.h
# make install copys linuxthreads/sysdeps/pthread/semaphore.h instead 
# of the correct one.
install -c -m 644 ../linuxthreads/semaphore.h \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_include_dir}

# Fix ld scripts (remove '/devel/lib/' and '/devel/usr/lib/').
for f in /usr/lib/libc.so /usr/lib/libpthread.so
do
    sed -e 's,%{sony_target_dev_dir}/[^ 	]*/,,g' \
	-e '/BUG in libc.scripts.output-format.sed/d' \
        %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_dir}$f > tmp.so
    mv -f tmp.so %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_dir}$f
done

# Install libc_pic in the correct location
install -m 644 elf/soinit.os   %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libc_pic/
install -m 644 elf/sofini.os   %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libc_pic/
install -m 644 elf/interp.os   %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libc_pic/

install -m 644 libc_pic.a      %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 libc.map        %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libc_pic.map

install -m 644 crypt/libcrypt_pic.a %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 libcrypt.map    %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypt_pic.map

install -m 644 dlfcn/libdl_pic.a %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 libdl.map       %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libdl_pic.map

install -m 644 math/libm_pic.a %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 libm.map        %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libm_pic.map

install -m 644 linuxthreads/libpthread_pic.a %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 libpthread.map  %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libpthread_pic.map

install -m 644 rt/librt_pic.a  %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/
install -m 644 librt.map  %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/librt_pic.map

# Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/optinfo
OBJECTDIR=`/bin/pwd`

# Install Library Optimizer information (libc)
install -m 755 %{SOURCE10} %{_optdir}/libc/build
install -m 644 libc.map %{_optdir}/libc/libc.map
install -m 644 shlib.lds %{_optdir}/libc/libc.so.lds
install -m 644 format.lds %{_optdir}/libc/format.lds
install -m 644 csu/abi-note.o %{_optdir}/libc/abi-note.o
install -m 644 elf/soinit.os %{_optdir}/libc/soinit.o
install -m 644 elf/sofini.os %{_optdir}/libc/sofini.o
install -m 644 elf/interp.os %{_optdir}/libc/interp.o
install -m 644 libc_nonshared.a %{_optdir}/libc/libc_nonshared.a
(cd %{_optdir}/libc; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/libc_pic.a)
(cd %{_optdir}/libc; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/libc.so -r *.o -o *.os > index)
(umask 022; echo "/devel/lib/libc-"%{version}".so" > %{_optdir}/libc/path)

# Install Library Optimizer information (libcrypt)
install -m 755 %{SOURCE11} %{_optdir}/libcrypt/build
install -m 644 libcrypt.map %{_optdir}/libcrypt/libcrypt.map
install -m 644 shlib.lds %{_optdir}/libcrypt/libcrypt.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libcrypt/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libcrypt/interp.o
install -m 644 libc_nonshared.a %{_optdir}/libcrypt/libc_nonshared.a
(cd %{_optdir}/libcrypt; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/crypt/libcrypt_pic.a)
(cd %{_optdir}/libcrypt; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/crypt/libcrypt.so -r *.o -o *.os > index)
(umask 022; echo "/devel/lib/libcrypt-"%{version}".so" > %{_optdir}/libcrypt/path)

# Install Library Optimizer information (libdl)
install -m 755 %{SOURCE12} %{_optdir}/libdl/build
install -m 644 libdl.map %{_optdir}/libdl/libdl.map
install -m 644 shlib.lds %{_optdir}/libdl/libdl.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libdl/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libdl/interp.o
install -m 644 libc_nonshared.a %{_optdir}/libdl/libc_nonshared.a
(cd %{_optdir}/libdl; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/dlfcn/libdl_pic.a)
(cd %{_optdir}/libdl; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/dlfcn/libdl.so -r *.o -o *.os > index)
(umask 022; echo "/devel/lib/libdl-"%{version}".so" > %{_optdir}/libdl/path)

# Install Library Optimizer information (libm)
install -m 755 %{SOURCE13} %{_optdir}/libm/build
install -m 644 libm.map %{_optdir}/libm/libm.map
install -m 644 shlib.lds %{_optdir}/libm/libm.so.lds
install -m 644 csu/abi-note.o %{_optdir}/libm/abi-note.o
install -m 644 elf/interp.os %{_optdir}/libm/interp.o
install -m 644 libc_nonshared.a %{_optdir}/libm/libc_nonshared.a
(cd %{_optdir}/libm; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/math/libm_pic.a)
(cd %{_optdir}/libm; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/math/libm.so -r *.o -o *.os > index)
(umask 022; echo "/devel/lib/libm-"%{version}".so" > %{_optdir}/libm/path)

# Install Library Optimizer information (libpthread)
install -m 755 %{SOURCE14} %{_optdir}/libpthread/build
install -m 644 libpthread.map %{_optdir}/libpthread/libpthread.map
install -m 644 libc.map %{_optdir}/libpthread/libc.map
install -m 644 shlib.lds %{_optdir}/libpthread/libpthread.so.lds
install -m 644 shlib.lds %{_optdir}/libpthread/libc.so.lds
install -m 644 format.lds %{_optdir}/libpthread/format.lds
install -m 644 csu/abi-note.o %{_optdir}/libpthread/abi-note.o
install -m 644 elf/soinit.os %{_optdir}/libpthread/soinit.o
install -m 644 elf/sofini.os %{_optdir}/libpthread/sofini.o
install -m 644 elf/interp.os %{_optdir}/libpthread/interp.o
install -m 644 libc_nonshared.a %{_optdir}/libpthread/libc_nonshared.a
install -m 644 linuxthreads/libpthread_nonshared.a %{_optdir}/libpthread/libpthread_nonshared.a
(cd %{_optdir}/libpthread; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/linuxthreads/libpthread_pic.a)
(cd %{_optdir}/libpthread; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/linuxthreads/libpthread.so -r *.o -o *.os > index)
cd $OBJECTDIR
#install -m 644 linuxthreads/libc-tsd.os %{_optdir}/libpthread/libc-tsd.o
install -m 644 linuxthreads/crti.o %{_optdir}/libpthread/crti.o
install -m 644 linuxthreads/crti.S %{_optdir}/libpthread/crti.S
install -m 644 linuxthreads/crtn.o %{_optdir}/libpthread/crtn.o
install -m 644 linuxthreads/crtn.S %{_optdir}/libpthread/crtn.S
(umask 022; echo "/devel/lib/libpthread-"%{version}".so" > %{_optdir}/libpthread/path)

# Install Library Optimizer information (librt)
install -m 755 %{SOURCE15} %{_optdir}/librt/build
install -m 644 librt.map %{_optdir}/librt/librt.map
install -m 644 shlib.lds %{_optdir}/librt/librt.so.lds
install -m 644 csu/abi-note.o %{_optdir}/librt/abi-note.o
install -m 644 elf/interp.os %{_optdir}/librt/interp.o
install -m 644 libc_nonshared.a %{_optdir}/librt/libc_nonshared.a
install -m 644 linuxthreads/libpthread_nonshared.a %{_optdir}/librt/libpthread_nonshared.a
(cd %{_optdir}/librt; umask 022; %{sony_target_toolprefix}ar x $OBJECTDIR/rt/librt_pic.a)
(cd %{_optdir}/librt; umask 022; %{sony_target_toolprefix}libindex $OBJECTDIR/rt/librt.so -r *.o -o *.os > index)
(umask 022; echo "/devel/lib/librt-"%{version}".so" > %{_optdir}/librt/path)

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)

%{sony_cross_target_dir}

%changelog
* Fri Sep 05 2008 Sony Corporation
- Add fix to initialize dl_load_lock lock at fork from thread.

* Sun Jul 13 2008 Sony Corporation
- Add fix for struct rtld_global mismatch between ld.so and libpthread.

* Thu Jun 12 2008 Sony Corporation
- Add dl-ld race MIPS patch. 

* Mon Mar 31 2008 Sony Corporation
- Add MIPS prelink support.

* Fri Feb 25 2008 Sony Corporation
- Add hp-timing support for x86,mips,ppc

* Fri Feb 22 2008 Sony Corporation
- Disable __thread TLS feature on MIPS, due to performance decline.

* Wed Nov 21 2007 Sony Corporation
- Add -g to CFLAGS
- Add linuxthreads sigwait() bugfix patch.

* Wed Oct 03 2007 Sony Corporation
- Add MIPS struct msqid_ds fix patch.

* Mon Sep 19 2007 Sony Corporation
- Replace ARM pselect() and ppoll() support patch.

* Mon Sep 10 2007 Sony Corporation
- Add MIPS gnu hash support.

* Mon Sep 03 2007 Sony Corporation
- Add patch to make mismatch of os version warning rather than fatal error
- Remove two space from the head of this changelog

* Wed Aug 29 2007 Sony Corporation
- Integrated CE3.x and CE4.x.

* Fri Aug 03 2007 Sony Corporation
- CE4.X: Modifiedkernel version to 2.6.22

* Wed Aug 01 2007 Sony Corporation
- Fix inet6_xxx() API

* Mon Jul 02 2007 Sony Corporation
- Added ARM pselect() and ppoll() support patch.

* Thu Jun 27 2007 Sony Corporation
- Add patch to fix resolver(#223)

* Thu May 31 2007 Sony Corporation
- CE3.X: Change kernel version to 2.6.16 back.
- CE4.X: Added "-O2 -fno-omit-frame-pointer" CFLAGS

* Fri May 30 2007 Sony Corporation
- Add patch for dl ld race (#222)
- Add patches MIPS/i386/arm-eabi (#301,#344,#345,#361)

* Fri May 27 2007 Sony Corporation
- Remove patch for MIPS rtld(#222), fixed at binutils

* Fri May 25 2007 Sony Corporation
- Add ARM bugfix patch.
- Modified kernel version to 2.6.21.

* Wed May 23 2007 Sony Corporation
- Add patch to fix ARM signal unwinding for newer kernel

* Mon Mar 28 2007 Sony Corporation
- Add patch to fix the glibc minor version

* Mon Mar 19 2007 Sony Corporation
- Add rtld fix for MIPS

* Mon Mar 16 2007 Sony Corporation
- Add installation for semaphore.h

* Mon Mar 16 2007 Sony Corporation
- Add patches,which were applied on 2.3.6(#220,#221)

* Mon Feb 26 2007 Sony Corporation
- Added patch #341.

* Thu Nov 10 2006 Sony Corporation
- Initial Build


